#!/usr/bin/perl

# NOTE:  the above line must be changed to show the path to the
# Perl interpreter on your system!  Leave the #! as is, but
# the path may have to be changed if yours is different.
#########################################################################
# RemindMe v3.0.7							#
# Allows users to have reminders automatically mailed to them on a	#
# date they select.  Useful for reminders about final exams, deadlines	#
# for publications, gift-giving occasions, or pretty much anything.	#
# the program allows you to determine a date, whether you want to be	#
# reminded annually or just once, and how far in advance you'd like to	#
# be reminded of the event or occasion.  Users may also use a password	#
# to get a list of all their pending reminders.				#
#									#
#########################################################################
##### Licensing:                                                        #
#####                                                                   #
#####  This program may be used free of charge under the following      #
#####  conditions:                                                      #
#####                                                                   #
#####  1. All instructions and Copyright lines must remain unchanged.   #
#####                                                                   #
#####  2. All pages generated by the program must contain one of the    #
#####     following pieces of HTML code:                                #
#####                                                                   #
#####     <font size=-2>RemindMe v3.0.7 Copyright 1997-2002             #
#####     Kristina Pfaff-Harris. It can be found at:                    #
#####     <a href="http://www.tesol.net/scripts/">                      #
#####     http://www.tesol.net/scripts</a></font>                       #
#####  OR:                                                              #
#####     <!-- RemindMe v3.0.7 Copyright 1997 Kristina Pfaff-Harris --> #
#####     <!-- Get it at http://www.tesol.net/scripts/         -->      #
#####                                                                   #
#####  3. You may not sell or distribute this program.  You may charge  #
#####     a reasonable fee for installing it for a client as long as    #
#####     you make it clear that you are not the author, and you are    #
#####     not selling the program to them: only charging for installing #
#####     it.                                                           #
#####                                                                   #
#####  4. You agree that this program is offered without warranty of    #
#####     any kind, including warranty of fitness for a particular      #
#####     purpose. You further agree that the author and all sites      #
#####     associated in any way with this program are not liable for    #
#####     any damage or loss incurred as a result of using this program.#
#####                                                                   #
#########################################################################
#####                                                                   #
##### IMPORTANT INSTRUCTIONS:                                           #
#####                                                                   #
##### In this program, I have put **CHANGE** in all the places where    #
##### you will need to modify the program to run on your server, so     #
##### that you can easily find all the places where changes are         #
##### necessary.  This program must be chmod 755 or 775 in order to     #
##### work, and the html  and configuration files must be chmod 644.    #
##### Note:  on some, systems, you'll have to either make the files     #
##### "allreminders", "optin.txt", "optout.txt", "temp_signup.txt",   	#
##### and "passfile.txt" world writeable (chmod 666) or you'll have     #
##### to make remindme.cgi run as you (chmod 4755).  Permissions    	#
##### are sometimes a bit tricky since there are so many different      #
##### operating systems and web servers. If you encounter problems,     #
##### please email me and I'll see what I can do!                       #
#####                                                                   #
##### In addition, if you are on a Unix/Linux based web server, it must #
##### have the "sendmail" program.  I think this may work with          #
##### "qmail-inject," but have no way to test it.
#####                                                                   #
#########################################################################
#									#
# Using the program:							#
#									#
# This program requires the files remindme.cgi,  optin.txt, optout.txt,	#
# temp_signup.txt, allreminders, and passfile.txt. Please see the file	#
# README.remindme for more instructions on how to set this up.		#
# 									#
# For auto-sending of reminders, the program also requires that you 	#
# have sendmail and cron available on your Unix server, or the "at" 	#
# command on NT. In addition, you must have the ability to set up "cron	#
# jobs" on your Unix server, or "at" jobs on your NT server.  If	#
# you do not, or if you don't know whether you do or not, ask your	#
# web hosting provider for instructions on how to set up a scheduled	#
# nightly task on your web server.  Please note that remindme.cron DOES	#
# NOT DO ANYTHING and it does NOT MATTER WHERE YOU PUT IT.  It is an	#
# example file only, intended to show you a possible example of what 	#
# a "cron" job might look like.  YOU MUST ask the technical support 	#
# people for YOUR website how to set up a regularly scheduled automatic	#
# task.  If your local technical support people cannot help you, I 	#
# suggest that you either find a web hosting service who will help you,	#
# send the reminders manually every day, or let RemindMe try to handle	#
# sending the reminders internally.					#
#									#
# I hope this program proves useful to you!  Please contact me  	#
# (http://tesol.net/scriptmail.html) for any bugs or feedback.		#
#########################################################################


   #################################################################
   #                                                               #
   #      Begin section where you need to change things. Keep      #
   #      going until you get the the place where it says          #
   #      "** Do not change anything beyond this point! **".       #
   #      Please read all the instructions carefully, and you      #
   #      shouldn't have any problems. :)                          #
   #                                                               #
   #################################################################

#### IMPORTANT!  If you are having trouble setting this up, or
#### finding where your files are supposed to be, you can use
#### the following to get some information about what the script
#### is trying to do, and where it's trying to look for files.
#### If you're having trouble, **CHANGE** $debugging = 0; to
#### $debugging = 1; and try running the script again.

$debugging = 0;

#### **CHANGE**
#### "cron" is the Unix/Linux automatic task scheduler.  If you would
#### like to use "cron" to automatically send reminders every day,
#### and IF you have access to cron on your website, then follow the
#### instructions in the README file to set up your cron job, and
#### set 
####
#### $cron = "cron"; 
####
#### below. On NT, the scheduler is called "at". If you are able to
#### use an "at" job on your NT server to send the reminders
#### automatically, then follow the instructions in the README file
#### to set up your "at job" and set:
####
#### $cron = "at";
####
#### below. If you do NOT have access to the cron or at commands,
#### RemindMe can try and send reminders every time it is accessed.  
#### This may slow down operation of the script if you have many 
#### reminders, but you won't have to remember to send
#### the reminders manually once a day.  If you wish to try this, set
####
#### $cron = "remindme"; 
####
#### below. Otherwise, if you wish to send
#### the reminders manually every day, set 
####
#### $cron = "manual"; 
####
#### below, and no reminders will be sent unless you manually send
#### them.

$cron = "remindme";

# $cgi_url is the full web address (URL) of the remindme.cgi program
# on your server. This *must* begin with "http://" and should end
# with "remindme.cgi" or "remindme.pl" depending on what you have
# named the remindme program. **CHANGE** this to the full URL of
# the RemindMe program on your server.

$cgi_url = "http://www.your.site/cgi-bin/remindme.cgi";

###################################################################
#                                                                 #
#                  Operating System Specific Stuff                #
#                      (Windows vs. Unix/Linux)                   #
#                                                                 #
###################################################################

# In this section, we're going to try to get some data that will
# help us run this script whether you're using Windows NT/95/98 as
# a web server, or a Unix/Linux-based web server.  Here, I feel
# it necessary to point out that Unix/Linux web servers tend to
# be much more flexible and robust (in my experience) than Windows
# ones.  However, if you're stuck with Windows, we'll try to get
# this working anyway. :)

# If your web server is Linux/Unix based, please **CHANGE**
# $opsys below to "unix" like this and go to the Unix/Linux Stuff
# Section below:
# $opsys = "unix";
# Otherwise, if it is a Windows-based platform, **CHANGE** $opsys to "win"
# like this and go to the Windows Stuff section:
# $opsys = "win";

$opsys = "unix";

###################################################################
#                                                                 #
#                  Unix/Linux Stuff                               #
#                                                                 #
###################################################################
# $path_to_sendmail needs to be the FULL path to sendmail on your
# server, and the name of the sendmail file itself:  You will
# probably be able to use what I have below, but sendmail
# is sometimes located in /usr/ucblib instead of /usr/lib and
# may be somewhere else altogether, like "/var/qmail/bin/qmail-inject",
# /bin/easymail, or really who knows what it might be on your server!
# The only way to find out is to ask the folks who run your website
# sendmail or your mailer program is, just to make sure, then **CHANGE**
# this to the correct path. NOTE: this is only the path to the file.
# Please do not include "-t" or other sendmail options, as the program
# will try to detect whether you are using sendmail or qmail and will
# try to add the appropriate options later.

$path_to_sendmail = "/usr/sbin/sendmail";

###################################################################
#                                                                 #
#                     Windows Stuff                               #
#                                                                 #
###################################################################

# $mail_server_hostname needs to be the hostname of a mail server
# that your web server is allowed to send mail through. Generally,
# this will be something like "mail.yourdomain.com" but it may
# be something completely different, and you may not be able to
# use this at all.  If your web server is also a mail server,
# you may be able to use "localhost" (yes, just that one word,
# no ".com" or anything -- it's a special word that means "this
# machine.")  You will need to ask your local technical support
# people for your website what hostname to use for your outgoing
# mail server, then **CHANGE** this to reflect that. For example:
# $mail_server_hostname = "mail.yourdomain.com";

$mail_server_hostname = "mail.your_domain.com";

# $this_server_hostname needs to be the hostname of your web
# server where this script will be run.  Sometimes, just the
# "www.yourdomain.com" will work, and sometimes your web
# server has its own name like "web-01.nt.somedomain.com".
# Again, you will need to get the hostname of this machine
# from the technical support people for your web server,
# and **CHANGE** this to reflect what they say. For example:
# $this_server_hostname = "www.yourdomain.com";

$this_server_hostname = "www.your_domain.com";

###################################################################
#                                                                 #
#            Various Email Preferences for this Program           #
# (You need this regardless of whether you have "win" or "unix".) #
#                                                                 #
###################################################################

# $opt_in_preferences:  Spam, or unsolicited email, has become a
# serious problem on the Internet.  Many hosting providers will terminate
# your account immediately if you are even suspected of sending Spam.
# Various U.S. states allow fines, civil penalties, and other legal
# actions to be taken against senders of junk email. This setting will
# help you make sure that only people who really want get reminders
# can sign up. Read the below instructions, and **CHANGE** this
# appropriately if necessary.
#
# opt in:  People will have to sign up, receive a special token
#          via email, and confirm their signup if they wish to get
#          reminders.  Note: Use of this feature is recommended.  If
#          you use this feature, and honestly abide by it, then you will
#          be able to prove that you are mailing responsibly. To use this,
#          set:
#
#          $opt_in_preferences = "opt in";
#
# opt out: Anyone can signup for reminders, but any email
#          they receive will allow them to opt-out or unsubscribe at
#          that time. Note that this will allow irresponsible people
#          to abuse this service by signing other people up, and could
#          cause trouble for you if your provider has a "No Tolerance"
#          policy on spam. To use this, set:
#
#          $opt_in_preferences = "opt out";
#

$opt_in_preferences = "opt in";

###################################################################
#                                                                 #
#            Locations of your configuration files                #
# (You need this regardless of whether you have "win" or "unix".) #
# In this section, we'll need to tell the program where it can    #
# find various files on your web server.                          #
#                                                                 #
###################################################################

# **CHANGE**
# $opt_out_file is the path to the file where you want to keep track
# of people who have opted NOT to ever receive email from this service.
# Change this to the full path of your "optout.txt" file. This file
# must be writeable by the web server.  Note: this is a "system"
# path and not a web address, thus, it must begin with a "/" (on unix-
# type systems) or "c:/" on Windows-type systems.

$opt_out_file = "/path/to/your/remindme/optout.txt";

# **CHANGE**
# $opt_in_file is the name of the file where you want to keep track
# of people who have opted back in.  I suggest you keep this
# indefinitely, in case someone accuses you of spamming them. :)
# Change this to the full path of your "optin.txt" file. This file
# must be writeable by the web server.  Note: this is a "system"
# path and not a web address, thus, it must begin with a "/" (on unix-
# type systems) or "c:/" on Windows-type systems.

$opt_in_file = "/path/to/your/remindme/optin.txt";

# **CHANGE**
# $temp_signup_file  is the full system path to your temporary
# signup file for users who "opt in" for your reminder service
# If you have "$opt_in_preferences = "opt in";" set, RemindMe
# will need a temporary file to store a special "token" that it will
# email to people when they try to sign up.  When the user receives the 
# email with their token, and clicks on the link, RemindMe will check in
# this file to make sure the token really matches what we sent them.

$temp_signup_file = "/path/to/your/remindme/temp_signup.txt";

# $password_file is the complete path and filename of "passfile.txt".
# **CHANGE** "passfile.txt" to the path and filename on your server.
# This is a "system path" like "$opt_in_file" and "$opt_out_file" above,
# so set it up the same way.

$password_file = "/path/to/your/remindme/passfile.txt";

# **CHANGE**
# $mail_footer_file is a text file containing any message that you
# would like to have appended to messages sent by the reminder
# service.  This should be the full system path to where you
# have the file remindme_footer on your server.  You can edit
# this file with a standard text editor, or use the 
# maintainreminder.html page to change the text.The path should
# be in the same format as for "allreminders" above.

$mail_footer_file = "/path/to/your/remindme/footer";

# **CHANGE**
# $allentries is the name of the file where you want to keep track of
# all the reminders.  You must change this to the location of the
# allreminders file on your server. This is a *system* path and 
# NOT a URL, thus # it must start with / and must NOT start with http://
# For example:  /home/users/yourname/cgi-bin/allreminders on Unix or
# c:/path/to/your/files/allreminders on Windows

$allentries = "/path/to/your/remindme/allreminders";

# $temp_reminders is the full system path to a temporary reminders
# file.  When a new user signs up for a reminder, and you have 'opt-in'
# set, the user's reminder will be stored in this file temporarily
# until they confirm their subscription.  This must be a full
# system path as with $allentries and other files above, and the
# file should be chmod 766.

$temp_reminders = "/path/to/your/remindme/temp_reminders.txt";

# $users_file is the full system path to where you want to keep
# track of your users and their passwords. When a user's last
# reminder is deleted, the user's username and password will be
# stored in this file so that they can sign up for more reminders
# without going through the whole signup process again. This
# must be a full system path as with $allentries and other files
# above, and the file should be chmod 766.

$users_file = "/path/to/your/remindme/users.txt";

###################################################################
#                                                                 #
#      Text and Page Display Preferences for this Program         #
# (You need this regardless of whether you have "win" or "unix".) #
# These are options for the name of your service, text to send if #
# someone signs up, any HTML you would like to use for when the   #
# program displays pages (so you can match the look of your site) #
# and so forth.)                                                  #
#                                                                 #
###################################################################

# **CHANGE**
# $header is the HTML header for any pages generated by the program.
# You may put any HTML you like in between the "header starts below
# this line" and "header ends above this line" remarks, but if
# you have any of the following characters: " @ % $ they must
# have a backslash \ in front of them.  For example:
# <a href=\"index.html\"> or kristina\@tesol.net

$header = "

<!-- header starts below this line -->

<HTML><HEAD><TITLE>RemindMe v3.0.7</TITLE></HEAD>
<body bgcolor=#ccffff>
<A HREF=http://www.tesol.net/scripts/index.html><img
src=/scripts/RemindMe/working/remindme2.jpg 
border=0 alt=\"RemindMe\"></A><BR><BR><BR>
<table cellpadding=0 border=0 cellspacing=0 width=500> <tr> <td>
<img src=dot.gif height=1 width=41 border=0><BR></td>
<td bgcolor=#ff0000 width=1>
<img src=dot.gif height=75 width=1 border=0><BR></td>
<td bgcolor=#ccffff width=10>
<img src=dot.gif height=75 width=10 border=0><BR></td><td>

<!-- header ends above this line -->

";

#**CHANGE**
# $footer is like $header above in that you can have any HTML
# you want, but must backslash the characters " @ % or $.
# This is the HTML that will appear at the bottom of each page
# generated by the program.

$footer = "

<!-- footer starts below this line -->

<P><center>
</center> </td> </tr> </table> <BR><BR><BR> </BODY> </HTML>

<!-- footer ends above this line -->

";


# **CHANGE**
# $reminder_page_text is just whatever text you'd like to be displayed
# at the top of the RemindMe signup form.  You can make this anything
# you like, and even include HTML, But remember: any " @ % or $ characters
# must be backslashed, as in $header and $footer above.

$reminder_page_text = "

<!-- reminder text starts below this line -->

Welcome to RemindMe version 3.0.7.  You may set up a reminder right away,
or just list any reminders you have pending.  Reminders are sent by email
once per day, and recurring reminders will be sent as often as you
specify.

<!-- reminder text ends above this line -->

";


# **CHANGE**
# $owner_name is the name that you want to use for your reminder service.
# It can be pretty much anything, but any " @ $ or % must be backslashed
# as in $header and $footer above.

$owner_name = "RemindMe v3.0.7";

# **CHANGE**
# $owner_email should be the email address of a real person whom
# reminder recipients can contact for bug reports or other information.
# Change this to your own email address.  Note that the @ sign in the
# email address must have a backslash in front of it.

$owner_email = "you\@your_domain.com";


# **CHANGE**
# $reminder_subject is what you want the subject of the reminder
# mail messages to be.  You may change this to just about anything
# bearing in mind that it will be the subject of a mail message
# and thus, should not be too long.

$reminder_subject = "Just a Reminder ...";

# **CHANGE**
# $mail_header will appear at the top of each mail message sent
# by the reminder service.  You may put whatever text you like
# in between the =-=-=-=-=-=- lines, but you must backslash
# @ % " and $ as in $header and $footer.  The default value simply
# uses what you entered for "$owner_name" and prints "This
# reminder is brought to you by $owner_name".

$mail_header = "
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
This reminder is brought to you by $owner_name.
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
";


   ###############################################################
   #                                                             #
   #           Congratulations!  You're all done!                #
   #                                                             #
   #       ** Do not change anything beyond this point! **       #
   #      You should NOT have to change anything beyond this     #
   #      point.  You can read through the code, though, if      #
   #      that sort of thing interests you. :)                   #
   #                                                             #
   ###############################################################
########################################################################
#####								   #####
#####    Don't change anything beyond this point.                  #####
#####								   #####
########################################################################
#
%data = &get_data();
# Debugging starts here...
# Some servers use software ID as Server Name. This will almost
# always be a host of some kind. :)

eval("use Time::Local;");
if ($@){ 
   print &ct;
   print "$header
	  Sorry, but this program requires Perl version 5 (Your version
	  of Perl is $]) with the Time::Local module.  Perl version 5 and
	  above comews with the Time::Local module, but your system does 
	  not appear to have the Time::Local module installed.  Please 
	  ask the technical support people or administrators of your 
	  website to install the Time::Local module, or you will not 
	  be able to use this program.
	  $footer";
   exit();
   }

# If you remove this link, without replacing it with a similar
# HTML comment (as above in the License section) you are in violation
# of the license for this program. No, I don't have the resources to
# enforce this, and I know that some people will remove it anyway.
# But honestly, since you didn't have to pay for this, is the link
# really too much to ask? :)

$footer = "<br><font size=1> RemindMe v3.0.7 copyright &copy; 2000 
           Kristina Pfaff-Harris and can be found at 
           <A HREF=http://www.tesol.net/scripts/>
           http://www.tesol.net/scripts/</A>.<br>$footer";

eval("use Cwd;");
unless ($@){
   $pwd = cwd;
   &debug("I think the working directory is $pwd.");
   }
&debug("\$path_to_sendmail is $path_to_sendmail.");
&debug("\$allentries is $allentries.");
 if(-f $allentries){&debug("$allentries exists. Good.");}
 else{&debug("Cannot find $allentries (user database file)");}
&debug("\$cgi_url is $cgi_url.");
&debug("\$mail_footer_file is $mail_footer_file.");
 if(-f $mail_footer_file){&debug("$mail_footer_file exists. Good.");}
 else{&debug("Cannot find $mail_footer_file (file to tack on the end of 
 mail messages)");}
&debug("\$password_file is $password_file.");
 if(-f $password_file){&debug("$password_file exists. Good.");}
 else{&debug("Cannot find $password_file (password file)");}

# $cron = cron is the same as $cron = at, and really
# just means that we're expecting RemindMe to send the
# reminders after being called by some outside entity.
if($cron eq "at"){$cron = "cron";}


# Send the reminders every time if we don't have cron
# and we don't want to do it manually.
if($cron eq "remindme"){ &send_reminders; }

$form_day = $data{'Day'};
$form_month = $data{'Month'};

if($data{'Year'} eq "Not Selected"){
  $form_year = (localtime(time))[5] + 1900;
   }

else{$form_year = $data{'Year'};}

%months = ('Jan',0,'Feb',1,'Mar',2,'Apr',3,'May',4,'Jun',5,
           'Jul',6,'Aug',7,'Sep',8,'Oct',9,'Nov',10,'Dec',11);

@howoften = ('Once Only','Annually','Semi-Annually',
	     'Quarterly','Bi-Monthly','Monthly',
	     'Bi-Weekly','Weekly','Daily');

$email = $data{'Email'};
$password = $data{'Password'};
$password2 = $data{'Password2'};
$sendme = $data{'Sendme'};
$remindme = $data{'Remindme'};
$message = $data{'Message'};
$filemessage = $message;
$filemessage =~ s/\r\n/\n/g;
$filemessage =~ s/\r/\n/g;
$filemessage =~ s/\n+$//sg;
$filemessage =~ s/\n/NEWLINE/g;


if ($data{'Formaction'} eq "Add"){
    &check_for_required_fields;
    &check_for_opt_out;
    &check_password;
    &convert_date("Added");
    }
elsif($data{'Formaction'} eq "List"){
    print &ct;
    &check_password;
    &list_reminders;
    }
elsif($data{'Formaction'} eq "Edit"){
    print &ct;
    &check_password;
    &edit_reminder;
    }
elsif($data{'Formaction'} eq "Delete"){
    print &ct;
    &check_password;
    &delete_reminder;
    }
elsif($data{'Formaction'} eq "Mailpassword"){
    print &ct;
    &mail_password;
    }
elsif ($ARGV[0] eq "send_reminders" ||
       $ENV{'QUERY_STRING'} eq "send_reminders"){
  if($cron eq "remindme"){
     # if $cron = "remindme" then we already ran
     # send_reminders, so just bail out. :)
     exit();
     }
  &send_reminders;
  }
elsif ($data{'Formaction'} eq "Edit_mail_footer"){
    print &ct;
    &edit_mail_footer;
   }
elsif($data{'Formaction'} eq "Change_password"){
   print &ct;
   &change_password;
   }
elsif($data{'Formaction'} eq "Opt In" ||
      ($data{'FA'} eq "oi")){
      #&& $data{'tk'} ne "" &&
      # $data{'em'} ne "")){

   print &ct;
   &opt_in;
   }
elsif($data{'FA'} eq "oo"){
   #$data{'em'} ne "" && $data{'pw'} ne ""){
   print &ct;
   &opt_out;
   }
elsif($ENV{'QUERY_STRING'} eq "admin"){
   print &ct;
   &admin_login;
   }
elsif($data{'FA'} eq "Admin Menu"){
   print &ct;
   &password_check;
   &manage;
   }

else{
print &ct;
&show_main_screen;
	exit();
}

sub check_for_required_fields {

  if ($email eq "" || $password eq "" || $sendme eq "" ||
	$form_day eq "" || $form_month eq "" || $form_year eq "" ||
	$remindme eq "" || $message eq ""){
        if ($password ne ""){
	   $password = "Entered: Not printed for security reasons.";
           }	
        print &ct;
	print "$header <center><strong>Error: Insufficient Data</strong>
	</center><P>I'm sorry, but you left something out of one of the
	following fields:<br><br>
	<dl>
	<dd>Email address: $email
	<dd>Password: $password<dd>How often to send: $sendme
	<dd>Day: $form_day<dd>Month: $form_month
	<dd>How far in advance: $remindme<dd>Message for yourself:<br>
	$message</dl><br>
	Please <a onClick=\"javascript:history.back();\"
	href=$ENV{'HTTP_REFERER'}>go back to the form</a>
	and fill out all fields.$footer";
	exit();
   }
}

sub check_password {

   open(FILE, "$allentries")
     || &debug("Can't open $allentries for reading: $!");
   # Look for a line beginning with their email address.
   @lines = grep(/^$email%%/, <FILE>);
   close(FILE);
   # If it's blank, they have no reminders, so check and see if they're
   # in the users file.
   if($ENV{'REMOTE_ADDR'} eq "207.228.31.47"){$debugging = 1;}
   if($lines[0] eq ""){
      open(USR, "$users_file") ||
       &debug("Could not open users file $users_file: $!");
       @lines = grep(/^$email%%/, <USR>);
      close(USR);
      }
   # We only really need the first line, so split the fields
   # in the first one we found.
   chomp($lines[0]); @fields = split("%%", $lines[0]);

   # If $fields[0] is empty, we found no entries with that email address.
   # Must be a new one going to add an entry, so make sure Formaction is
   # Add, and make sure they entered the password twice.

  if($data{'Formaction'} eq "Add"){

     # Either they are a new member, or we need to check the password.
     if($fields[0] eq ""){

        if($data{'Password'} eq $data{'Password2'} &&
           $data{'Password'} ne "" && $data{'Password2'} ne ""){
           $pass_check = 1;
           }
        else {
           print &ct;
           print "$header Non-Matching passwords<br><br>
                It appears that this is your first time using
                this service, or else you have no reminders in the
                system. For your privacy, your address is removed from
                the database when all your reminders have been sent,
                but you can sign up for more reminders at any time -- just
                choose a new password (or the same one you used before
                if you like!) and sign up again.
                <br><br>In order to make sure that you
                will be able to use your password later, we
                need to have you confirm what you'd like your
                password to be.  However, the two passwords
                you entered did not match, or you did not enter a password
                at all.  Please <a
                onClick=\"javascript:history.back();\"
                href=$ENV{'HTTP_REFERER'}>
                go back to the form</a> and try again.$footer";
                exit();
                }
           }
       else {
         # We need to check their pw
         if($password eq $fields[1] &&
            $password ne "" && $fields[1] ne "" && 
	    $fields[0] eq $email && $email ne ""){
            $pass_check = 1;
            }
         else {
	  if($fields[0] ne $email){
             $errorlist = "<b>Error: No such email address ($email) on file.</b>";
	     &show_main_screen;
	     exit();
	     }
          print &ct;
          print "$header<center><strong>Sorry, Incorrect Password
                </strong></center><br><br>
                The password that you entered does not match
                the one we have on file for $email.  If you feel
                this is incorrect, please <a
                onClick=\"javascript:history.back();\"
                href=$ENV{'HTTP_REFERER'}>
                return to the form</a> and try again, or have
                your password mailed to you by clicking below.
                <form action=$cgi_url>
                <input type=hidden name=Formaction value=Mailpassword>
                <input type=hidden name=Email value=$email>
                <input type=submit value=\"Mail me my password.\">
                </form>$footer";
                exit();

            }
         }
       } # end if formaction eq Add

       # If the formaction is NOT Add, then we must have found $fields[0].
       # Also, $fields[0] MUST match $email. If not, it is an incorrect
       # password
       else {
       # Formaction is not Add.
         if($password eq $fields[1] &&
            $password ne "" && $fields[1] ne ""){
            $pass_check = 1;
            }
         else {
	  if($email eq "" || $password eq ""){
             $errorlist = "<b>Error: Please enter your email address and 
			   password to list your reminders.</b>";
	     &show_main_screen;
	     exit();
	     }
	  if($fields[0] ne $email){
             $errorlist = "<b>Error: No such email address ($email) on file.</b>";
	     &show_main_screen;
	     exit();
	     }
          print &ct;
          print "$header<center><strong>Sorry, Incorrect Password
                </strong></center><br><br>
                The password that you entered does not match
                the one we have on file for $email.  If you feel
                this is incorrect, please <a
                onClick=\"javascript:history.back();\"
                href=$ENV{'HTTP_REFERER'}>
                return to the form</a> and try again, or have
                your password mailed to you by clicking below.
                <form action=$cgi_url>
                <input type=hidden name=Formaction value=Mailpassword>
                <input type=hidden name=Email value=$email>
                <input type=submit value=\"Mail me my password.\">
                </form>$footer";
                exit();

            }
          }

}
sub mail_password {

  undef $/;
  open(FILE, "$mail_footer_file") || &debug("Can't open $mail_footer_file for reading: $!");
  $mailfooter = <FILE>;
  close(FILE);
  $/ = "\n";
   open(FILE, "$allentries") || &debug("Can't open $allentries for reading: $!");
   @lines = grep(/^$email%%/, <FILE>);
   close(FILE);
   chop($lines[0]);
   @fields = split("%%", $lines[0]);
   if($fields[0] eq $email){
   $mailmessage = "
Here is your password for the $owner_name service:

  $fields[1]

This password will only be mailed to the email address we
have on file for you.";
$mailmessage .= "\n$mailfooter";
   $subject = "Auto-mail password";
   &send_mail($fields[0],"$fields[0]",$owner_email,$owner_name,
	      $owner_email,$owner_name,$subject,$mailmessage,
	      $mail_server_hostname,$this_server_hostname,$opsys,
	      $htmlmail);

  print &ct;
  print "$header<center><strong>Success!</strong></center><br><br>
	  Your password has been mailed to you at the address we
	  have on file. $footer";
	  exit();
	  }
  else {
    print &ct;
    print "$header<center><strong>Error: Email not found</strong></center>
	   <br><br>
	   Sorry, but I couldn't find the email address \"$email\" anywhere 
	   in my database.
	   Please try again.$footer";
	   exit();
	   }

}

sub list_reminders {

if($email eq ""){
  print &ct;
  &show_main_screen("<table border=1><tr><td bgcolor=#FFFFFF><font color=#FF0000><center><b>Error: No email address. Please enter your email address so we can find your reminders.</b></center></font></td></tr></table>");
  exit();
	 }
open(FILE, "$allentries") || &debug("Can't open $allentries for reading: $!");
@lines = grep(/^$email/, <FILE>);
close(FILE);
if ($lines[0] eq ""){
   print &ct;
  &show_main_screen("<table border=1><tr><td bgcolor=#FFFFFF><font color=#FF0000><center><b>You have no reminders waiting at this time.</b></center></font></td></tr></table>");
	exit();
	}
else {

     # Put the reminders in ascending date order
     @lines = sort {
     (split(/\%%/, $a))[3] cmp (split(/\%%/, $b))[3];
     } @lines;

     print &ct;
     print "$header<br>$_[0]<BR>
	    <center><strong>Reminders Pending</strong></center>
	   <hr>
	   <table border=1>
	   <tr><th>Date</th><th>Send Reminder on:</th><th>How Often</th><th>How Far<br>in advance</th><th>Message</th><th colspan=2>Action</th>
	   </tr>";
#"$email%%$password%%$sendme%%$remindmeon_seconds%%$remindme%%$remindmeof_seconds%%$filemessage\n";
     foreach $line (@lines){
	  @fields = split("%%", $line);
	  $reminder_date = &get_date($fields[5]);
          $fields[$#fields] =~ s/NEWLINE/<br>/g;

	  if($fields[4] == 1){ $fields[4] = "1 day"; }
	  else { $fields[4] = "$fields[4] days"; }
          $oldline = $line; chomp($oldline);
	  print "<form method=POST action=$ENV{'SCRIPT_NAME'}>
		 <input type=hidden name=Email value=\"$data{'Email'}\">
		 <input type=hidden name=Password value=\"$data{'Password'}\">
		 <input type=hidden name=Oldline value=\"$oldline\">
		 <tr><td>".&get_date($fields[5])."</td>
		     <td>".&get_date($fields[3])."</td>
		     <td>$fields[2]</td>
		     <td>$fields[4]</td>
		     <td>$fields[6]</td>
		     <td bgcolor=#C0C0C0><input type=submit 
		     name=Formaction value=Edit></td>
		     <td bgcolor=#C0C0C0><input type=submit 
		     name=Formaction value=Delete></td>
		 </tr></form>\n";
	  }
    print "</table>$footer";
    }
}

sub convert_date {

$month = $months{$form_month};
print &ct;
$remindmeof_seconds = timelocal(0,0,0,$form_day,$month,$form_year);

if($remindmeof_seconds < time){
   print &ct;
   $bad_date = &get_date($remindmeof_seconds);
   print "$header <font size=+1>Error: Invalid date</font>
	  <br><br>
	  You have requested to be reminded of a date that
	  is either today, or that has already passed ($bad_date). Please
	  check your entry and try again.
	  $footer";
   exit();
   }

$number = $remindme;
$number =~ s/\D+//g;
if($number > 365 || $number < 1 || $number eq ""){
 print &ct;
 print "$header <font size=+1>Error</font><br><Br>
	You have requested to be reminded more than 1 year or less
	than one day in
	advance of your requested date. This program only supports
	sending reminders one day to one year in advance.  Please
	<a onClick=\"javascript:history.back();\"
	href=\"$ENV{'HTTP_REFERER'}\">try again</a>.
	$footer";
	exit();
   }

#                         this day - this many days in advance
$remindmeon_seconds = ($remindmeof_seconds) - (86400 * $number);

if($remindmeon_seconds < (time - 86400)){
   print &ct;
   $bad_date = &get_date($remindmeon_seconds);
   print "$header <font size=+1>Error: Invalid date</font>
	  <br><br>
	  You have requested to be reminded on a date that
	  is either today, or that has already passed ($bad_date). Please
	  check your entry and try again.
	  $footer";
   exit();
   }
$chosen_date = &get_date($remindmeof_seconds);
$remind_date = &get_date($remindmeon_seconds);

#if ($date_only eq "Yes"){
#     break;
#   }
if ($form_month eq "Feb" && $form_day > 28 && 
       (int($form_year / 4) ne $form_year / 4)){
	&invalid_date;
	}
elsif ($form_month eq "Feb" && $form_day > 29){
        &invalid_date;
	}
elsif (($form_month eq "Sep" || $form_month eq "Apr" ||
	$form_month eq "Jun" || $form_month eq "Nov") && 
	$form_day > 30){
	&invalid_date;
	}
else {

if($_[0] eq "temp_only"){
 open(FILE, ">>$temp_reminders") || &debug("Can't open temporary reminders
 file to add reminder: $!");
 if($opsys eq "unix"){ flock(FILE, 2);}
 print FILE 
"$email%%$password%%$sendme%%$remindmeon_seconds%%$remindme%%$remindmeof_seconds%%$filemessage\n";
 close(FILE);
 return;
 }
open (FILE, ">>$allentries") || &debug("Can't open $allentries to add reminder: $!");
if($opsys ne "win"){
 flock(FILE, 2) || 
 &debug("Can't lock $allentries: $!. Do you have file locking?");
 }
 print FILE 
"$email%%$password%%$sendme%%$remindmeon_seconds%%$remindme%%$remindmeof_seconds%%$filemessage\n";
close(FILE);

$remind_date =~ s/\n//;
$chosen_date =~ s/\n//g;
  undef $/;
  open(FILE, "$mail_footer_file") || &debug("Can't open $mail_footer_file for reading: $!");
  $mailfooter = <FILE>;
  close(FILE);
  $/ = "\n";

$mailmessage = "$mail_header

Thank you for using the $owner_name Reminder Service.  

You asked to be reminded $sendme $remindme days in advance of 
$chosen_date for the following:

$message";
$mailmessage .= "\n$mailfooter\n";
   $mailmessage .= "
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
To permanently remove your email address from our reminder service,
use this link:
 $cgi_url?FA=oo&em=$email
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=";
 $subject = "Subject: Reminder added";
 &send_mail($email,"$email",$owner_email,$owner_name,
            $owner_email,$owner_name,$subject,$mailmessage,
	    $mail_server_hostname,$this_server_hostname,$opsys,$htmlmail);

 print &ct;
 if($_[0] eq "Modified"){
   &list_reminders("<center><strong>Reminder Successfully $_[0]</strong></center><br><br>The date you chose is $chosen_date.\n<br>You want to be reminded of the following $sendme,$remindme day(s) in advance of that date. ($remind_date):<br><br>$data{'Message'}");
   }
 else {
   &show_main_screen("<center><strong>Reminder Successfully $_[0]</strong></center><br><br>The date you chose is $chosen_date.\n<br>You want to be reminded of the following $sendme,$remindme day(s) in advance of that date. ($remind_date):<br><br>$data{'Message'}");
   }
  exit();
}

}
sub invalid_date {
print &ct;
print "$header 
        Sorry, but $form_month $form_day, $form_year is an invalid date.
	Please <a onClick=\"javascript:history.back();\"
	href=$ENV{'HTTP_REFERER'}>Try Again</a>
	$footer";
	exit();
}



sub send_reminders {

if($ENV{'QUERY_STRING'} eq "send_reminders"){
  print &ct;
  $rstart = time;
  print "$header Sending reminders.";
  }
my($line, @lines, @fields);
open(REMINDERS, "+<$allentries") || &debug("In \&send_reminders: Can't open $allentries for reading: $!");
if($opsys ne "win"){
 flock(REMINDERS, 2) || &debug("Can't lock $allentries: $!");
 }
@lines = grep(!/^#/, <REMINDERS>);

foreach $line (@lines){
   ($email,$pw,$sendme,$remindmeon,$remindme,$remindmeof,$filemessage) = split("%%", $line);
#"$email%%$password%%$sendme%%$remindmeon_seconds%%$remindme%%$remindmeof_seconds%%$filemessage\n";
   $remindmeon_date = &get_date($remindmeon);
   $remindmeof_date = &get_date($remindmeof);
   $todays_date = &get_date();

   chomp($line);
   &debug("Today's date is '$todays_date' Reminder date is '$remindmeon_date'");
   if ($remindmeon_date eq $todays_date){
	    &debug("Sending reminder...");
	    &mail_reminder;
	    if($sendme eq "Annually"){ $update = 31536000; }
	    elsif($sendme eq "Semi-Annually"){ 
	       $newtime = &update_monthly($remindmeon,6);
	       $update = $newtime - $remindmeon;
	       }
	    elsif($sendme eq "Quarterly"){
	       $newtime = &update_monthly($remindmeon,3);
	       $update = $newtime - $remindmeon;
	       }
	    elsif($sendme eq "Bi-Monthly"){
	       $newtime = &update_monthly($remindmeon,2);
	       $update = $newtime - $remindmeon;
	       }
	    elsif($sendme eq "Weekly"){ $update = 7 * 86400; }
	    elsif($sendme eq "Bi-Weekly"){ $update = 14 * 86400; }
	    elsif($sendme eq "Daily"){ $update = 86400; }
	    else {
	       $newtime = &update_monthly($remindmeon,1);
	       $update = $newtime - $remindmeon;
	       }
             
	    $date_to_be_reminded_on = $remindmeon + $update; 
	    $new_remind_date = $remindmeof + $update; 
	    $line = "$email%%$pw%%$sendme%%$date_to_be_reminded_on%%$remindme%%$new_remind_date%%$filemessage";
	    # Get rid of nasty cr/lf
	    $line =~ s/\r\n/\n/g;
	    $line =~ s/\r/\n/g;
	    $line =~ s/\n+$//g;
	    $line =~ s/\r\n/NEWLINE/g;
	    $line =~ s/\r/NEWLINE/g;
	    $line =~ s/\n/NEWLINE/g;

   	    if($line =~ /%%Once Only%%/){
		# Just save their username/password in the users
		# file.
		&check_users_file($email,$pw);
		# But delete the reminder from the file.
		$line = "";
		}
	    }
    if ($line ne ""){
	$newfile .= "$line\n";
	}
    } #end foreach line
    truncate(REMINDERS, length($newfile));
    seek(REMINDERS, 0, 0);
    print REMINDERS $newfile;
    close(REMINDERS);
    if($ENV{'QUERY_STRING'} eq "send_reminders"){
       print &ct;
       $rend = time - $rstart;
       $sentr = $sentr * 1;
       print " Sent $sentr reminders in $rend seconds. $footer";
       }

}

sub update_monthly  {

  my ($u_day,$u_mon,$u_year) = (localtime($_[0]))[3,4,5];
  my $newtime;
  my $i;
  my $num = $_[1];

  $u_year = $u_year + 1900;
  for($i = 1; $i <= $num; $i++){
     $u_mon += 1;
     if($u_mon > 11){
        $u_mon = 0;
        $u_year = $u_year + 1;
        }
     }
  # If the month is feb, make sure it doesn't go over
  # the last day of the month.
  if($u_mon == 1 && $u_day > 28){
     $u_day = 28;
     }
  if(($u_mon == 3 || $u_mon == 5 ||
     $u_mon == 8 || $u_mon == 10) &&
     $u_day > 30){
     $u_day = 30;
    }
  $newtime = timelocal(0,0,0,$u_day,$u_mon,$u_year);
  $newtime;
}

sub mail_reminder {
  $todays_date =~ s/\n//g;
  $remind =~ s/\n//g;
  undef $/;
  open(FILE, "$mail_footer_file") || &debug("In \&mail_reminders: Can't open $mail_footer_file for reading: $!");
  $mailfooter = <FILE>;
  close(FILE);
  $/ = "\n";
 $filemessage =~ s/NEWLINE/\n/g;


#   "$email%%$password%%$sendme%%$remindmeon_seconds%%$remindme%%$remindmeof_seconds%%$filemessage\n";
  &debug("Opening mail to $email to send reminder...");

  &get_date();
   $mailmessage = "$mail_header\n";
   $mailmessage .= "
Sent: $date

Here's your reminder for $remindmeof_date ($remindme day(s) in advance):

$remindmeof_date

    $filemessage";
   $mailmessage .= "\n\n$mailfooter\n";
   $mailmessage .= "
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
To permanently remove your email address from our reminder service,
use this link:
 $cgi_url?FA=oo&em=$email
=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=";
   $subject = "$reminder_subject";
   &send_mail($email,"$email",$owner_email,$owner_name,
	      $owner_email,$owner_name,$subject,$mailmessage,
	      $mail_server_hostname,$this_server_hostname,$opsys,
	      $htmlmail);
}

sub edit_mail_footer {
  print &ct;
  &password_check;
  undef $/;
  open(FILE, "$mail_footer_file") || 
  &debug("In \&edit_mail_footer: Can't open $mail_footer_file for reading: $!");
  $mailfooter = <FILE>;
  close(FILE);
  $/ = "\n";
if ($data{'edit_footer'} eq ""){

  print "$header<center><strong>Edit Mail Footer</strong></center>
	Below is the text you entered.  Please be sure that it
	is the way you like it before clicking \"Save Changes\".
	 <form method=POST action=$cgi_url><br>
	 <input type=hidden name=edit_footer value=Yes>
	 <textarea name=Newfooter rows=6 cols=50>$data{'Newfooter'}</textarea>
	<br>
	<center><strong>Your previous text is reprinted below</strong>
	</center><br>
	 <pre>\n$mailfooter\n</pre>
	 <input type=hidden name=Password value=$data{'Password'}>
   	 <input type=hidden name=Formaction value=Edit_mail_footer>
	 <input type=submit value=\"Save Changes\">
	 <input type=button onClick=\"javascript:history.back();\" value=\"No, Go back.\">
	 </form>$footer";
         exit();
        }
elsif ($data{'edit_footer'} eq "Yes"){

  open(FILE, ">$mail_footer_file") 
    || &debug("In \&edit_mail_footer: Can't open $mail_footer_file for writing: $!");
  if($opsys ne "win"){
     flock(FILE, 2) || &debug("Can't lock $mail_footer_file. $!");
     }

 	print FILE "$data{'Newfooter'}";
  close(FILE);

  print "$header<strong><center>Success!</center></strong><br><br>
	Your mail footer has been changed to the following.  If you
	have made an error, please <a onClick=\"javascript:history.back();\"
	href=$ENV{'HTTP_REFERER'}>
	go back</a> and correct it.<br>
	<pre>
$data{'Newfooter'}
</pre>
$footer";
}
}

#########################################################################
##### 	3.  check_password:  "encrypts" the password and checks		#
#####	    it against the encrypted site maintenance password. 	#
#####	    This is still NOT very secure, since anyone who can read  	#
#####	    your passfile.txt file can probably also read this program  #
#####       and thus figure it out. 					# 
#####	    Really it's just in here so we don't have passwords in 	#
#####	    open text form sitting on your server.  If this is really 	#
#####	    VITAL that this is not cracked, then put server side 	#
#####	    security on your web server and use a different program.	#
#########################################################################

sub password_check {

$password = $data{'Password'};

# Read the password from the password file...
 open (FILE, "<$password_file") 
   || &debug("In \&password_check: Can't open $password_file for reading: $!");
 if($opsys ne "win"){
   flock(FILE, 2) || &debug("Could not lock file. $!");
   }
    $real_password = <FILE>;
    chomp($real_password);
 if($real_password eq "password"){
    $real_password = crypt("password",time.$$);
    truncate(FILE, length($real_password));
    seek(FILE, 0, 0);
    print FILE "$real_password";
    }
 close(FILE);


 $new_password = $password;

# "Encrypt" the password you entered so it will match the
#  one in the file...If they match, it's okay.

 if (crypt($password,$real_password) eq "$real_password"){
   $pass_check = 1;
   }

# If they don't match, print out an "Incorrect Password" message,
# allowing you to go back and change it, and exit the program. 

 else {
    print &ct;
    $pass_check = 0;
    print "$header<hr><strong>Sorry, incorrect password.</strong>
	   Please <a onClick=\"javascript:history.back();\"
	   href=\"$ENV{'HTTP_REFERER'}\">try again</a>.
	   <hr>$footer\n";
    exit();
    }
}

#########################################################################
##### 	7.  change_password:  Allows you to change your password	#
#####	    with some minor error checking to make sure that your	#
#####	    new password matches.					#
#########################################################################

sub change_password {
$password = $data{'Password'};
$new_password1 = $data{'New_password'};
$new_password2 = $data{'New_password2'};
&password_check;
print &ct;
 if ($new_password1 ne $new_password2 || $new_password1 eq "" ||
     $new_password2 eq "") {
  	print "$header<hr><strong>
	Error:  New Password and Confirm New Password do not match.
	Please try again: </strong><P>
	<form method=\"POST\" action=\"$cgi_url\">
	<table border=0>
	<tr><td><strong>New Password: </strong></td>
	<td><input type=password size=20 name=\"New_password\"></td></tr>
   	<tr><td><strong>Confirm New Password:</strong></td>
	<td><input type=password size=20 name=\"New_password2\"></td></tr>
	</table>
	<input type=hidden name=\"Action\" value=\"Changing\">
	<input type=hidden name=\"Password\" value=\"$data{'Password'}\"><br><br>
	<input type=hidden name=Formaction value=Change_password>
  	<input type=submit value=\"Change Password\"><input type=reset>
	</form>
	<hr>
	$footer";
	exit();
	}

 else {
   $new_password1 = crypt($new_password1, time.$$);
 open (PASSFILE, ">$password_file") 
 || &debug("In \&change_password: Can't open $password_file for writing: $!");
   	  print PASSFILE "$new_password1";
     	close(PASSFILE);
     	print "$header<hr><strong>Password Successfully Changed!</strong>
                 <form method=POST action=$ENV{'SCRIPT_NAME'}>
                 <input type=hidden name=Password value=\"$new_password2\">
                 <input type=hidden name=FA value=\"Admin Menu\">
                 <input type=submit value=\"Return to administration\">
                 </form>
	       <hr>$footer";
    	}
}

sub get_date {

    $date_in_seconds = $_[0];
    @months = ('January','February','March','April','May','June','July',
              'August','September','October','November','December');

if($date_in_seconds ne ""){
   ($sec,$min,$hour,$mday,$mon,$year) = (localtime($date_in_seconds))[0,1,2,3,4,5];
   }
else {
   ($sec,$min,$hour,$mday,$mon,$year) = (localtime(time))[0,1,2,3,4,5];
   }

   $year += 1900;
   $date = "$months[$mon] $mday, $year";
   if($_[1] eq "long"){
      $mon = sprintf("%.2d", $mon + 1);
      $mday = sprintf("%.2d", $mday);
      $hour = sprintf("%.2d", $hour);
      $min = sprintf("%.2d", $min);
      $sec = sprintf("%.2d", $sec);
      $date = "$mon/$mday/$year $hour:$min:$sec";
      }
   $date;

}

sub debug {

 if($debugging == 1){
   print &ct;
   print "DEBUGGING INFO: $_[0]<br>\n";
   if(!$ENV{'QUERY_STRING'}){print "\n";} else{print "<br>\n";}
   }
 elsif($debugging eq "die"){
   die("$_[0]");
   }
}

sub send_mail {

   local($toemail,$toname,$fromemail,$fromname,
         $replytoemail,$replytoname,$subject,
         $message,$mail_server_hostname,$this_server_hostname,$opsys,
	 $htmlmail) = @_;

  &debug("Attempting to send message \"$subject\" to $toemail");
  my($boundary) = crypt("blah",time.$$).time.$$;

if($opsys eq "win"){
   $port = 25;
   $them = "$mail_server_hostname";
   $AF_INET = 2; $SOCK_STREAM = 1;

   $SIG{'INT'} = 'dokill';
   sub dokill {
       kill 9,$child if $child;
   }

   $sockaddr = 'S n a4 x8';

   $hostname = "$this_server_hostname";

   ($name,$aliases,$proto) = getprotobyname('tcp');
   ($name,$aliases,$port) = getservbyname($port,'tcp')
       unless $port =~ /^\d+$/;;
   ($name,$aliases,$type,$len,$thisaddr) =
        gethostbyname($hostname);
   ($name,$aliases,$type,$len,$thataddr) = gethostbyname($them);

   $this = pack($sockaddr, $AF_INET, 0, $thisaddr);
   $that = pack($sockaddr, $AF_INET, $port, $thataddr);

   if (socket(S, $AF_INET, $SOCK_STREAM, $proto)) {
   }
   else { &debug("Could not create socket for mail: $!"); }

   if (bind(S, $this)) {
   }
   else { &debug("Could not bind to socket (this may be okay anyway): $!"); }

   if (connect(S,$that)) {
   }
    else { &debug("Could not connect to socket: $!"); }

   select(S); $| = 1; select(STDOUT);

   $a=<S>; 
   print S "HELO $this_server_hostname\n";
   $a=<S>;  &debug("Mail server responded: $a");
   print S "MAIL FROM:<$fromemail>\r\n";
   $a=<S>;  &debug("Mail server responded: $a");
   print S "RCPT TO:<$toemail>\r\n";
   $a=<S>;  &debug("Mail server responded: $a");
   print S "DATA \r\n";
   $a=<S>;  &debug("Mail server responded: $a");
   print S "To: $toname <$toemail>\n";
   print S "From: $fromname <$fromemail>\n";
   if($replytoemail ne ""){
      print S "Reply-to: $replytoname <$replytoemail>\n";
      }
   print S "Subject: $subject\n";
   if($htmlmail eq "yes"){ 
     print S "MIME-Version: 1.0\n";
     print S "Content-type: MULTIPART/MIXED; BOUNDARY=\"$boundary\"\n";
     print S "--$boundary\n";
     print S "Content-type: text/html;\n\n";
     print S "$message\n";
     print S "\n\n";
     print S "--$boundary\n";
     print S "Content-type: TEXT/PLAIN; charset=US-ASCII\n\n";
     print S "$message--$boundary--\n";
     }
   else {
      print S "\n"; 
      print S "$message\n";
      }
   print S ".\n";
   $a=<S>; &debug("Mail server responded: $a");
   print S "QUIT";
   &debug("Sending mail done.");

   }

elsif($opsys eq "unix"){

   # Allow for qmail-inject ~sigh~
   # Most other mailer thingies do use the -t option like
   # sendmail in order to be compatible, but apparently
   # qmail-inject does not. Oh well...

   if($path_to_sendmail !~ /qmail-inject/){
      $path_to_sendmail = "$path_to_sendmail -t";
      }

   open(MAIL, "|$path_to_sendmail") || 
     &debug("Could not open sendmail: $!");
     print MAIL "To: \"$toname\" <$toemail>\n";
     print MAIL "From: \"$fromname\" <$fromemail>\n";
     if($replytoemail ne ""){
       print MAIL "Reply-to: \"$replytoname\" <$replytoemail>\n";
       }
     print MAIL "Subject: $subject\n";
     if($htmlmail eq "yes"){ 
        print MAIL "MIME-Version: 1.0\n";
        print MAIL "Content-type: MULTIPART/MIXED; BOUNDARY=\"$boundary\"\n";
        print MAIL "--$boundary\n";
        print MAIL "Content-type: text/html;\n\n";
        print MAIL "$message\n";
        print MAIL "\n\n";
        print MAIL "--$boundary\n";
        print MAIL "Content-type: TEXT/PLAIN; charset=US-ASCII\n\n";
        print MAIL "$message--$boundary--\n";
        }
     else {
        print MAIL "\n"; 
        print MAIL "$message\n";
        }
     close(MAIL) || &debug("Sending mail got an error: $! $?");
     &debug("Sending mail done.");
   }

else {

   &debug("Cannot send mail. '$opsys' is not a valid operating sytem.
           Please set \$opsys to either 'unix' or 'win' in the script
           and try this again.");
    }
}
sub get_data {
    local($string);

    # get data
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        $string = $ENV{'QUERY_STRING'};
    }				
    else { read(STDIN, $string, $ENV{'CONTENT_LENGTH'}); }

    # split data into name=value pairs
    @data = split(/&/, $string);
   
    # split into name=value pairs in associative array
    foreach (@data) {
	split(/=/, $_);
	$_[0] =~ s/\+/ /g; # plus to space
	$_[0] =~ s/%00//g; # We don' need no steenking nulls :)
        $_[0] =~ s/%0a/newline/g;
	$_[0] =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
	if(defined($data{$_[0]})){ 
	   $data{$_[0]} .= "\0";
	   $data{$_[0]} .= "$_[1]";
	   }
	else {
	$data{"$_[0]"} = $_[1];
	  }
    }
    # translate special characters
    foreach (keys %data) {
	$data{"$_"} =~ s/\+/ /g; # plus to space
	$data{"$_"} =~ s/%00//g; # We don' need no steenking nulls :)
        $data{"$_"} =~ s/%0a/newline/g;
	$data{"$_"} =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
    }

    %data;			# return associative array of name=value
}

sub ct {

 my $mimeheader;
 if($already_printed != 1){ 
    $mimeheader = "Content-type: text/html\n\n";
    $already_printed = 1;
    }
 $mimeheader;

}

sub edit_reminder {
 print &ct;
 $oldline = $data{'Oldline'};
 my ($em,$pw,$sm,$rofs,$rm,$rons,$msg) = split(/%%/, $oldline);
#"$email%%$password%%$sendme%%$remindmeon_seconds%%$remindme%%$remindmeof_seconds%%$filemessage\n";
 if($data{'Confirm'} ne "Yes"){

    print "$header
	   $_[0]
           <form method=POST action=$ENV{'SCRIPT_NAME'}>
	   <input type=hidden name=Email value=\"$data{'Email'}\">
	   <input type=hidden name=Password value=\"$data{'Password'}\">
<table border=0>
<tr><td colspan=2><hr></td></tr>
<tr><th colspan=2>Send me a reminder
<select name=Sendme>";

  foreach $howoften (@howoften){
    if($sm eq $howoften){ $ck = " SELECTED"; }
    else {$ck = "";}
    print "<option$ck>$howoften\n";
    }
print "</select> and remind me 
       <input type=text name=Remindme size=4 value=$rm> days in
       advance of <select name=Day>";
  ($tday,$tmon,$tyear) = &get_date_as_numbers((split(/%%/,$oldline))[5]);
  for($i = 1; $i <= 31; $i++){
     if($i == $tday){ $ck = " SELECTED"; } else { $ck = ""; }
     print "<option$ck>$i</option>\n";
     }
print "</select> <select name=Month>\n";
  @values = sort(values(%months));
  %mon_by_value = reverse %months;
  foreach $key (sort(keys(%mon_by_value))){
     if($key eq $tmon){
	$ck = " SELECTED";
     } else {
	$ck = "";
	}
     print "<option$ck>$mon_by_value{$key}\n";
     }
  print "</select> <select name=Year>\n";
  $nyear = (&get_date_as_numbers(time))[2];
  $nyear += 1900;
  $tyear += 1900;
  for ($i = $nyear; $i < $nyear + 10; $i++){
     if($tyear eq $i){$ck = " SELECTED"; } else {$ck = "";}
     print "<option$ck>$i</option>\n";
     }
$msg =~ s/NEWLINE/\n/g;
print "</select></td></tr>
       <tr><td colspan=2><hr></td></tr>
       <tr><th colspan=2 align=center>Please enter a message for yourself:<br></tr>
       <tr><td colspan=2 align=center>
       <textarea name=Message cols=50 rows=3>$msg</textarea><br></tr>
       <input type=hidden name=Formaction value=Edit>
       <input type=hidden name=Confirm value=Yes>
       <input type=hidden name=Oldline value=\"$oldline\">
       <tr><td colspan=2>
       <input type=submit value=\"Make Changes\">
       </td></tr></table></form>$footer";
   exit();
   }
  else {
     &delete_from_file($oldline);
     &convert_date("Modified");

  }


}

sub delete_from_file {
     print &ct; 
     my $oldline = $_[0];
     my $newfile = "";
     open(FILE, "+<$allentries") ||
       &debug("Error: Could not open $allentries (reminders file) for
	       read/write. The system returned $!");
     if($opsys ne "win"){
       flock(FILE, 2) ||
       &debug("Could not lock $allentries (reminders file). The system
	       returned $!");
       }
     @lines = grep(!/^#/, <FILE>);
     foreach $line (@lines){

       chomp($line);
       if($line ne $oldline){
	  $newfile .= "$line\n";

	   }
        }
     truncate(FILE, length($newfile));
     seek(FILE, 0, 0);
     print FILE "$newfile";
     close(FILE);
}

sub delete_reminder {

 print &ct; 
 my($oldline) = $data{'Oldline'};
 my ($em,$pw,$sm,$rofs,$rm,$rons,$msg) = split(/%%/, $oldline);
 if($data{'Confirm'} ne "Yes"){
    print "$header
	   <form method=POST action=$ENV{'SCRIPT_NAME'}>
	   <input type=hidden name=Email value=\"$data{'Email'}\">
	   <input type=hidden name=Password value=\"$data{'Password'}\">
	   <input type=hidden name=Formaction value=\"Delete\">
	   <input type=hidden name=Oldline value=\"$data{'Oldline'}\">
	   <input type=hidden name=Confirm value=\"Yes\">
	   <center><b>Confirm Deletion</b></center>
	   <br><br>
	   <table border=0>
	   <tr><th colspan=2 align=left>Please confirm that you wish to delete this reminder:</th>
	   </tr>
	   <tr><th align=right>
	   Date:</th><td>".&get_date($rons)."</td></tr>
	   <tr><th align=right>
	   Next Reminder to be sent:</th><td>".&get_date($rofs)."</td></tr>
	   <tr><th align=right>
	   Sent how often:</th><td>$sm</td></tr>
	   <tr><th align=right>
	   Sent when:</th><td>$rm days in advance</td>
	   </tr>
	   <tr><th colspan=2 align=right>
	   <input type=submit value=\"Yes, Delete this reminder\">
	   </th></tr></table>
           </form>
	   $footer";
     exit();
    }
 else {
     &check_users_file("$data{'Email'}","$data{'Password'}");
     &delete_from_file($oldline);
     &list_reminders("<center><b>Reminder deleted: </b>Your reminder for ".&get_date($rons)." has been deleted.</center><br>");
     exit();

    }


}

sub get_date_as_numbers {

  my @date = (localtime($_[0]))[3,4,5];
  @date;

}

sub show_main_screen {

  print "$header
         <center>
         <strong>
	 $_[0]
	 <br>$errorlist<br>
	 <a href=\"#list_reminders\">List my Reminders</a>
	 </strong><br>
<br>
<form method=POST action=$cgi_url>
<table border=0>
<tr><th align=left colspan=2>$reminder_page_text</th></tr>
<tr><td colspan=2><hr></td></tr>
<tr><th align=left>Your email address:</th>
<td><input type=text name=Email size=15 value=\"$data{'Email'}\"></td></tr>
<tr><th align=left>Your Password:</th>
<td><input type=password name=Password size=15 value=\"$data{'Password'}\"></td></tr>
<tr><th align=left>Your Password again if<br>this is your first visit:</th>
<td><input type=password name=Password2 size=15></td></tr>
<tr><td colspan=2><hr></td></tr>
 <tr><th align=left>Send me a reminder</th><td><select name=Sendme>
<option>Once Only
<option>Annually
<option>Semi-Annually
<option>Quarterly
<option>Bi-Monthly
<option>Monthly
<option>Bi-Weekly
<option>Weekly
<option>Daily
</select></td></tr>
<tr><th align=left>How Far in Advance:</th><td><select name=Remindme>
<option value=1>1 day
<option value=3>3 days
<option value=7>1 week
<option value=21>3 weeks
<option value=30>1 month
<option value=180>6 months
</select></td></tr>
<tr><th align=left>Date to Remember:</th><td><select name=Day>";
  ($tday,$tmon,$tyear) = &get_date_as_numbers(time);
  for($i = 1; $i <= 31; $i++){
     if($i == $tday){ $ck = " SELECTED"; } else { $ck = ""; }
     print "<option$ck>$i</option>\n";
     }
print "</select> <select name=Month>\n";
  @values = sort(values(%months));
  %mon_by_value = reverse %months;
  foreach $key (sort(keys(%mon_by_value))){
     if($key eq $tmon){
	$ck = " SELECTED";
     } else {
	$ck = "";
	}
     print "<option$ck>$mon_by_value{$key}\n";
     }
  print "</select> <select name=Year>\n";
  $tyear += 1900;
  for ($i = $tyear; $i < $tyear + 10; $i++){
     if($tyear eq $i){$ck = " SELECTED"; } else {$ck = "";}
     print "<option$ck>$i</option>\n";
     }
  
print "</select></td></tr>
<tr><td colspan=2><hr></td></tr>
<tr><th align=center colspan=2>Please enter a reminder message for 
yourself:</th></tr>
<tr><td align=center colspan=2>
<textarea name=Message cols=40 rows=5>This is a very important date. 
</textarea></td></tr>
<tr><input type=hidden name=Formaction value=Add>
<td colspan=2 align=center><input type=submit value=\"Add Reminder\"></td></tr>
</form>
</table></center>
<hr>
<center>
<strong>
<a name=list_reminders>List Reminders:</a>
</strong>

<form method=POST action=$cgi_url>

<input type=hidden name=Formaction value=List>
<table border=1>
<tr><th>
 <table border=0><tr><th align=right>Email address:</th>
   <td><input type=text name=Email size=15></td></tr>
   <tr><th align=right>Password:</th>
   <td><input type=password name=Password size=15></td></tr>
<tr><th colspan=2><input type=submit value=\"List Reminders\"></tr>
</form>
   </table></th></tr>
</table>
</center>
<hr>
$footer";
exit();

}


sub opt_out {

 my $email = $data{'em'};
 if($email eq ""){
    print "$header
	   <b>Error: no email</b><br><br>
	   Please enter your email address.  This email address will
	   be removed from our list, and placed in our \"opt out\"
	   database so that it cannot be used to sign up for 
	   reminders again.
	   <form method=POST action=$ENV{'SCRIPT_NAME'}>
	   <input type=hidden name=FA value=oi>
	   <input type=text name=em>
	   <input type=submit value=\"Opt Out\">
	   </form>
	   $footer";
     exit();
     }

  $newfile = "";
  # If they have reminders, get rid of 'em.
 open(FILE, "+<$allentries") ||
   &debug("Could not open $allentries (Reminder database) for
	   read/write. System returned: $!");
 if($opsys ne "win"){
    flock(FILE, 2) || 
    &debug("Could not lock $allentries (Reminder database). The
	   system returned $!");
    }

 @lines = <FILE>;
 foreach $line (@lines){
    if($line !~ /^$email%%/i){
       $newfile .= $line;
       }
   }
  truncate(FILE, length($newfile));
  seek(FILE, 0, 0);
  print FILE $newfile;
  close(FILE);
  $newfile = "";

  # If they previously opted in, take them out of there.
 open(FILE, "+<$opt_in_file") ||
   &debug("Could not open $opt_in_file (Opt In file) for
	   read/write. System returned: $!");
 if($opsys ne "win"){
    flock(FILE, 2) || 
    &debug("Could not lock $opt_in_file (Opt In File). The
	   system returned $!");
    }
 @lines = <FILE>;
 foreach $line (@lines){
    if($line !~ /^$email\|/i){
       $newfile .= $line;
       }
   }
  truncate(FILE, length($newfile));
  seek(FILE, 0, 0);
  print FILE $newfile;
  close(FILE);
  $newfile = "";

  # If they are in the users file, remove them.
 open(FILE, "+<$users_file") ||
   &debug("Could not open $users_file (users file) for
	   read/write. System returned: $!");
 if($opsys ne "win"){
    flock(FILE, 2) || 
    &debug("Could not lock $users_file (users File). The
	   system returned $!");
    }
 @lines = <FILE>;
 foreach $line (@lines){
    if($line !~ /^$email%%/i){
       $newfile .= $line;
       }
   }
  truncate(FILE, length($newfile));
  seek(FILE, 0, 0);
  print FILE $newfile;
  close(FILE);
  $newfile = "";
  
  # If they're in the tmp signup file, get 'em out of there.
  
 open(FILE, "+<$temp_signup_file") ||
   &debug("Could not open $temp_signup_file (Temp. signup file) for
	   read/write. System returned: $!");
 if($opsys ne "win"){
    flock(FILE, 2) || 
    &debug("Could not lock $temp_signup_file (Temp. signup file). The
	   system returned $!");
    }

 @lines = <FILE>;
 foreach $line (@lines){
    if($line !~ /^$email\|/i){
       $newfile .= $line;
       }
   }
  truncate(FILE, length($newfile));
  seek(FILE, 0, 0);
  print FILE $newfile;
  close(FILE);
  $newfile = "";

  # Put it on the opt-out list
  open(FILE, ">>$opt_out_file") ||
   &debug("Could not open $opt_out_file (opt-out file) for
	   writing. System returned: $!");
  if($opsys ne "win"){
     flock(FILE, 2) ||
     &debug("Could not lock $opt_out_file. $!");
     }
  seek(FILE, 0, 2);
   print FILE "$data{'em'}\n";
  close(FILE);
  print "$header
	 $data{'em'} successfully deleted.  This address has been
	 removed from our reminder database, and
	 added to our \"Off-Limits\" list so that no one may
	 sign up for reminders with this address in the future.  
	 Should you wish 
	 to use the reminder service in the future, please choose the
	 \"Opt In\" button or <a href=\"mailto:$owner_email\">contact
	 the webmaster</a>.
	 $footer";
  exit();
}


sub check_for_opt_out {

 open(FILE, "$opt_out_file") || 
  &debug("Could not open $opt_out_file (opt out file) for reading.
	  The system returned $!");
 while(<FILE>){
   if($_ =~ /^$email$/i){
      print &ct;
      print "$header
	     <strong><center>Error: $email has opted out</center></strong>
	     <br><br>
	     <form method=POST action=$ENV{'SCRIPT_NAME'}>
	     The owner of the email address $email has used the
	     \"opt out\" feature of this service.  This means that
	     this email address may no sign up for reminders.
	      If this is your email address, and you 
	     wish to opt back in,  please click the 
	     <input type=hidden name=Email value=\"$email\">
	     <input type=hidden name=Password value=\"$data{'Password'}\">
	     <input type=hidden name=Password2 value=\"$data{'Password2'}\">
	     <input type=hidden name=Sendme value=\"$data{'Sendme'}\">
	     <input type=hidden name=Remindme value=\"$data{'Remindme'}\">
	     <input type=hidden name=Message value=\"$data{'Message'}\">
	     <input type=hidden name=Day value=\"$data{'Day'}\">
	     <input type=hidden name=Month value=\"$data{'Month'}\">
	     <input type=hidden name=Year value=\"$data{'Year'}\">
	     <input type=hidden name=Send value=\"Token\">
	     <input type=hidden name=FA value=\"oi\">
	     <input type=submit value=\"Opt In\">
	     button.</form>
	     $footer";
       exit();
       }
  }
 if($opt_in_preferences eq "opt in"){
    if(&check_opt_in != 1){
       $data{'Send'} = "Token";
       &opt_in("Quiet");
       print &ct;
       print "$header
	      <center><strong>Confirmation Required</strong></center>
	      <br><br>
	      This Reminder service requires a confirmation
	      in order to prevent others from signing you up for
	      reminders without your consent.  You have been
	      sent an email with a special link.  When you receive the
	      email, please click on the link, or copy and paste it into
	      your browser to enable your subscription.  
	      $footer";
        exit();
	}


  }

}


sub opt_in {
 if($data{'Send'} eq "Token"){
    for($i = 0; $i < 50; $i++){
       $rand[$i] = $i;
       }
    $token = crypt(int(rand(@rand)),time.$$);
    open(FILE, ">>$temp_signup_file") ||
     &debug("Could not open temporary signup file for writing: $!");
    if($opsys ne "win"){
       flock(FILE, 2) || 
       &debug("could not lock ($temp_signup_file) temporary signup file. $!");
       }
    my $date = &get_date(time,"long");
    print FILE "$email|$token|$ENV{'REMOTE_ADDR'}|$date\n";
    close(FILE);
    # Save their reminder to a temporary file so if they opt in,
    # we can set it up. Previously this was terribly confusing to
    # people.
    &convert_date("temp_only");

    $mailmessage = "

Hello.  Someone has requested to \"opt in\" to our Reminder
service using this email address:

 $email

To prevent abuse of the system, we are sending this confirmation
message to you to let you decide if this is what you want.  If 
you wish to use our service, please use this link:

 $cgi_url?FA=oi&tk=$token&em=$email

If you do not wish to sign up, just ignore this message and no 
action will be taken.

To permanently opt out of our reminder service:

 $cgi_url?FA=oo&em=$email

---
$owner_name
$owner_email";

    &send_mail($email,"$email",$owner_email,$owner_name,
	      $owner_email,$owner_name,"Confirm Opt-In",$mailmessage,
	      $mail_server_hostname,$this_server_hostname,$opsys);
    print &ct;
    print "$header
	  <strong><center>Opt-In Process Begun</center></strong>
	  <br><br>
	  Thank you for your request to opt in to our Reminder
	  service!  We have sent an email to $email
	  with a special link to confirm that you truly do wish
	  to opt in. When you receive the email, please click on 
	  that link, or copy it and paste it into your browser.
	  At that time, you may sign up for reminders!
	  $footer" unless $_[0] eq "Quiet";
    exit() unless $_[0] eq "Quiet";


    }
  else {

    # Look for them in the temp signup file to match their token, and
    # take them out if we do find them...
    open(FILE, "+<$temp_signup_file") ||
     &debug("Could not open $temp_signup_file for read/write: $!");
    if($opsys ne "win"){
       flock(FILE, 2) ||
       &debug("could not lock $temp_signup_file: $!");
       }
    @lines = <FILE>;
    foreach $line (@lines){
      if($line =~  /^$data{'em'}\|$data{'tk'}\|/i){
	 $foundit = 1;
	 $oldline = $line;
	 }
      else {
	 $newfile .= $line;
	 }
      }
    truncate(FILE, length($newfile));
    seek(FILE, 0,0);
    print FILE $newfile;
    close(FILE);
    $newfile = "";
    
    if($foundit == 1){
       open(FILE,"+<$opt_out_file") ||
	&debug("Could not open $opt_out_file for writing: $!");
       if($opsys ne "win"){
	  flock(FILE, 2) ||
	  &debug("Could not lock $opt_out_file: $!");
	  }
       @lines = <FILE>;
       foreach $line (@lines){
	 if($line !~ /^$data{'em'}$/){
	    $newfile .= $line;
	    }
	 }
       truncate(FILE, length($newfile));
       seek(FILE, 0, 0);
       print FILE $newfile;
       close(FILE);
       $newfile = "";
       
       # Put them on the opt-in list for proof later...
       open(FILE, ">>$opt_in_file") ||
	&debug("Could not open $opt_in_file for writing: $!");
       if($opsys ne "win"){
	  flock(FILE, 2) ||
	  &debug("Could not lock $opt_in_file: $!");
	  }
       seek(FILE, 0, 2);
       chomp($oldline);
       my $date = &get_date(time,"long");
       $oldline = "$oldline|$ENV{'REMOTE_ADDR'}|$date\n";
       print FILE $oldline;
       close(FILE);

       # Get their temporary reminder and set that up for real.
       open(TMP, "<$temp_reminders") ||
	&debug("Could not open temp_reminders file for reading: $!");
	@reminders = grep(/^$data{'em'}%%/, <TMP>);
       close(TMP);
       open(FILE, ">>$allentries") ||
	&debug("Could not open allentries/reminders file for writing: $!");
       if($opsys eq "unix"){flock(FILE, 2);}
	foreach $reminder (@reminders){
	   print FILE "$reminder";
	   }
	close(FILE);

       &show_main_screen("Welcome! The Opt In process is complete, and you may now sign up for reminders");
       exit();
       
       }
    else {

       print "$header<center><strong>Error: Token not found or does not
	       match email address!
	       </strong></center>
	       <br><br>
	       When you signed up, we emailed you a link with
	       a special token.  The link looks something like this:
	       <p>
	       $cgi_url?FA=oi&amp;tk=97ch56XNTyh/A&amp;em=you\@your_email_address
	       <p>
	       Some email programs will not
	       let you click on the link directly, or they may
	       not include the whole link.  If this is the
	       case, please go back to your mail program and 
	       make sure to copy the full link and paste it
	       into your browser.  If you continue to 
	       experience this error, please <a href=mailto:$owner_email>
	       contact the webmaster.</a>
	       $footer";
	exit();


       }
   }       	 
	 
 
}


sub check_opt_in {

my($foundit);
   # check to see if they're on the opt-in list, and 
   # if not
   open(FILE, "<$opt_in_file");
     while(<FILE>){
       if($_ =~ /^$email\|/i){
	  $foundit = 1;
	  last;
	  }
       }
   close(FILE);
   $foundit;
}

sub manage {

 print &ct;
if(-f "$mail_footer_file"){
 open(FILE, "$mail_footer_file");
  while(<FILE>){$filefooter .= $_;}
 close(FILE);
 }
print <<EOF;
$header
<FONT SIZE=4>Welcome to RemindMe Administration!</FONT> 
<table border=0>
<tr><td colspan=2><b>Use this function to change your Administrator Password. 
(The password you use to access this screen.)</b></td></tr>
<tr><td></td><td></td></tr>
	<form method=\"POST\" action=\"$cgi_url\">
	<tr><td><strong>New Password: </strong></td>
	<td><input type=password size=20 name=\"New_password\"></td></tr>
   	<tr><td><strong>Confirm New Password:</strong></td>
	<td><input type=password size=20 name=\"New_password2\"></td></tr>
	<input type=hidden name=Formaction value=Change_password>
	<input type=hidden name=\"Password\" value="$data{'Password'}"><br><br>
	<input type=hidden name=\"Action\" value=\"Changing\">
  	<tr><td colspan=2><input type=submit value=\"Change Password\">
	<input type=reset value="Clear Passwords"></td></tr>
	</form>
</table>
<hr>
<FORM method=POST ACTION="$ENV{'SCRIPT_NAME'}">

<b>Use this area to change the text that is appended to all messages
sent by the RemindMe service.  You can make this just your
organization name and email address, or anything you like.
<br><br>IMPORTANT:
Remember, this is plain text only.  If you enter HTML, it will come out
as plain text.</b>
<br>
<INPUT TYPE="hidden" NAME="Password" value="$data{'Password'}" size=20>
<br>
<B>Enter THE NEW TEXT here --&gt;</B><BR>

<TEXTAREA wrap=hard NAME="Newfooter" ROWS=6 COLS=50>$filefooter</TEXTAREA>
<BR>
<input type=hidden name=Formaction value="Edit_mail_footer">
<INPUT TYPE="Submit" VALUE="Change text NOW">
<INPUT TYPE="Reset" value="Reset This Text Area">
</form>
<hr>
$footer
EOF
}
sub admin_login {
 print &ct;
 print "$header
        <form method=POST action=$ENV{'SCRIPT_NAME'}>
        <b>Please enter your password for RemindMe
Administration:</b>
        <input type=password name=Password value=\"$data{'Password'}\">
        <input type=hidden name=FA value=\"Admin Menu\">
        <input type=submit value=\"Log in\">
        </form>
        $footer";
 exit();
}

# &check_users_file($email,$pw);
sub check_users_file {
  my($email,$pw) = @_;
  my($test);
  open(USR, "<$users_file") || &debug("Could not open users file: $!");
   $test = (grep(/^$email%%/, <USR>))[0];
  close(USR);
  if($test eq ""){
  # Add them
     open(USR, ">>$users_file") || &debug("Could not open users file: $!");
       print USR "$email%%$pw\n";
     close(USR);
     }


}
